<?php
//* *******Licence**************
//MyPlanet v0.3
//Auteur : Sylvain Saleur
//syeric1@gmail.com
//
//avec l'aide prcieuse de Laurent Lamand
//Licence GNU GPL v3
//
//avec l'aide de certaines fonctions crites par Dominique WOJYLAC et retravailles
//************************************************************

// chemin relatif vers le dossier cache
// le rpertoire "cache" doit tre autoris en criture
// ne pas oublier /  la fin
define(DIR_CACHE, '../data/cache/');

if (!is_dir(DIR_CACHE)) {
	exit ('Rpertoire cache "'.DIR_CACHE.'" inexistant !');
}
require "functions.php";
//
function getFeedsById_ajax($cat, $confirm, $trackcge, $img){
	if (!$cat){
	$cat="0";
}
	global $feeds;
	//$tab=feedList();
	$tab=feedList2();
	//$cpt=0;
	foreach ($tab as $feed){
		if ($feed["CATEGORIE"]==$cat){
			//if (!($cpt%2 == 1)){
				$testcge=affiche_fil_ajax($feed["ADRESSE"],$feed["NOM"],$feed["REFRESH"],$feed["NBARTICLES"],$trackcge, $img);
			//}
		$cpt++;
		}

	}
	//$cpt2=0;
	/*foreach ($tab as $feed){
		if ($feed["CATEGORIE"]==$cat){
			if ($cpt2%2 == 1){
				affiche_fil_ajax($feed["ADRESSE"],$feed["NOM"],$feed["REFRESH"],$feed["NBARTICLES"],$trackcge);
			}
		$cpt2++;
		}
	}*/
	if ($testcge!=0) {
		$confirm="OK";}
		return $confirm;
		
//}			
}
//
function feedsAsPlanet_ajax($cat, $confirm, $trackcge){
	if (!$cat){
	$cat="0";
}
	global $feeds;
	$tab=feedList2();
	$cpt=0;
	$cpt2=0;
	$arr=array();
	$arr2=array();
	foreach ($tab as $feed){
		if ($feed["CATEGORIE"]==$cat){
			$arr[$cpt]=$feed["ADRESSE"];
		}
		$cpt++;
	}
	$testcge=affiche_fil_planet_ajax($arr, 'planet'.$cat.'.html', 1, 2, $trackcge);
	if ($testcge!=0) {
		$confirm="OK";
	}
	return $confirm;
		
}

//fonction pour trouver la version majeure de php
function phpversion_major(){
	$v = phpversion();
	$version = Array();

	foreach(explode('.', $v) as $bit)
	{
		if(is_numeric($bit))
		{
			$version[] = $bit;
		}
	}

	return $version[0];
}
//fonction de rduction de la taille des chanes.
function limitSize($char){
	$max_size = 300;
	$words = preg_split("/[\040]+/", $char, -1);
	$r=0;
	for($i=0; $i < count($words); $i++) {
		if (strlen($line[$r] . $words[$i] . ' ') < $max_size) $line[$r] .= $words[$i] . ' ';
		else
			{
		$r++;
		$line[$r] .= $words[$i] . ' ';
			}
	}
	$finalchar=$line[0];
	return $finalchar;
}
//fonction de traitement des chanes
function clean_text($text, $encodage = '') {
	//remarque : php4 ne semble pas rsoudre la condition $encodage == 'ISO-8859-1', si quelqu'un trouve pourquoi...
	$ver = phpversion_major();
	switch ($ver) {
		case '4':
			if ($encodage != 'utf-8') {
				$text = utf8_encode($text);
			}
		break;
		case '5':
			if ($encodage == 'ISO-8859-1') {
				$text = utf8_encode($text);
			}
		break;}
	//rduction de la taille de la chane 
	$text=limitSize($text);
	$avant = array(
		'&lt;',
		'&gt;',
		'&quot;',
		'&amp;',
		'|@|'
		);
	$apres = array(
		'<',
		'>',
		'"',
		'&',
		'&#'
		);
	$text = str_replace($avant, $apres, $text);
	$text=strip_tags($text);
	return $text;
}
function clean_date($date) 
{
	// si 'AAAA-MM-JJTHH:MM:SS+00:00' ou 'AAAA-MM-JJTHH:MM:SSZ'
    if (ereg("^[0-9]",$date) and  ereg("(([[:digit:]]|-)*)T(([[:digit:]]|:)*)[^[:digit:]].*",$date,$temp)) {
		$date = $temp[1].' '.$temp[3];
	}
	// affichage au format franais
	setlocale(LC_TIME, 'fr_FR');
	// rgler ici le format d'affichage des dates
	$date = strftime("%d/%m/%Y", strtotime($date));
	$date = utf8_encode($date);
	return $date;	
}
function clean_date2($date) 
{
	// si 'AAAA-MM-JJTHH:MM:SS+00:00' ou 'AAAA-MM-JJTHH:MM:SSZ'
    if (ereg("^[0-9]",$date) and  ereg("(([[:digit:]]|-)*)T(([[:digit:]]|:)*)[^[:digit:]].*",$date,$temp)) {
		$date = $temp[1].' '.$temp[3];
	}
	// affichage au format franais
	setlocale(LC_TIME, 'fr_FR');
	// rgler ici le format d'affichage des dates
	$date = strftime("%Y/%m/%d", strtotime($date));
	$date = utf8_encode($date);
	return $date;	
}

require_once 'rss_read.inc.php';


function affiche_fil_ajax($fil, $file_cache, $delai, $n_items = 0, $check, $img) {

	// le fichier est-il en cache et suffisamment jeune
	$file_cache = DIR_CACHE.$file_cache;
	// $delai en secondes
	$delai = round($delai*3600);
	$rss = new rss_read();
	$date = time();

	$en_cache = file_exists($file_cache);
	if ($en_cache) {
		$en_cache = ($date < filemtime($file_cache) + $delai);
	}
	
	if (!$en_cache) {
		$check++;
		// il est considr comme n'tant pas en cache on le gnre
		$data = '';
		
		// caractres parasites pouvant tre contenus dans le fils
		// doit tre invoqu avant parsefile
		// cette fonction est optionnelle et ne doit tre utilise que pour certains fils.
		$avant = array('&#','&bull;');
		$apres = array('|@|','-');
		$rss -> to_replace_with($avant, $apres);

		// parser le fichier news
		$rss -> parsefile($fil, $n_items);
		
		if ($rss) {
			$encode = $rss -> get_encoding();
			
			// recupration des donnes sur le channel
			$channel = $rss -> get_channel();
			
			// affichage site, url
			$data = "<div class=\"post\">";
			$data .= "<div class=\"post-title\">";
			$data .=  '<h2><a href="'. $channel['link'].'">'. clean_text($channel['title'], $encode). '</a>&nbsp;&nbsp;<a href="'.$fil.'"><img src="'.$img.'" alt="rss" /></a></h2>';
			$data .= "</div>";
			// nombre d'items 
			$nbnews = $rss -> get_num_items();
			
			// recup array des donnes 
			$items = $rss -> get_items();
			$data .= "<div class=\"post-content\">";
			for($i = 0; $i < $nbnews; $i++) { 
				$data .= '<ul><li><a href="'.$items[$i]['link'].'">'.clean_text($items[$i]['title'], $encode).'</a> le <em>'.clean_date($items[$i]['pubdate']).'</em></li></ul>'.clean_text($items[$i]['description'], $encode).'&nbsp;<a href="'.$items[$i]['link'].'">suite...</a>'."\n"; 
			}
			$data .= "</div></div>";
			
			
		} // fin if $rss
		
		$fd = fopen($file_cache, "w");
		fputs($fd, $data);
		fclose($fd);
		//$check=$check+1;
	
	} // fin if $en_cache
	return $check;
	
} // fin affiche_fil
function affiche_fil_planet_ajax($fil, $file_cache, $delai, $n_items = 0, $check) {
	$file_cache = DIR_CACHE.$file_cache;
	$delai = round($delai*3600);
	$date = time();
	$en_cache = file_exists($file_cache);
	if ($en_cache) {
		$en_cache = ($date < filemtime($file_cache) + $delai);
	}
	if (!$en_cache) {
		$check++;
		$data = '';
		$data .= '<div class="post-planet">';
		$tab = array();
		foreach ($fil as $key => $feed){
			$rss = new rss_read();
			$avant = array('&#','&bull;');
			$apres = array('|@|','-');
			$rss -> to_replace_with($avant, $apres);
			$rss -> parsefile($feed, $n_items);
			if ($rss) {
				$encode = $rss -> get_encoding();
				$channel = $rss -> get_channel();
				$nbnews = $rss -> get_num_items();
				$items = $rss -> get_items();
				for($i = 0; $i < $nbnews; $i++) { 
				$tab[$feed.$i] = array("pubdate" =>clean_date2($items[$i]['pubdate']), "link" =>$items[$i]['link'], "title"=>clean_text($items[$i]['title'], $encode), "maintitle" =>clean_text($channel['title'], $encode), "mainlink" => $channel['link'], "content" => clean_text($items[$i]['description'], $encode));
				}
			}
		}
			// Obtient une liste de colonnes
		foreach ($tab as $key => $row) {
				$pubdate[$key]  = $row['pubdate'];
				$link[$key] = $row['link'];
			$title[$key] = $row['title'];
			$maintitle[$key] = $row['maintitle'];
			$mainlink[$key] = $row['mainlink'];
			$content[$key] = $row['content'];
		}

		array_multisort($pubdate, SORT_DESC, $link, SORT_ASC, $title, SORT_ASC, $maintitle, SORT_ASC, $mainlink, SORT_ASC, $content, SORT_ASC, $tab);
		foreach ($tab as $key => $cont){
		$data .= "<div class=\"post-title-planet\">";
		$data .=  '<h2><a href="'.$cont['link'].'">'.$cont['title'].'</a></h2> le <em>'.clean_date($cont['pubdate']).'</em> depuis <a href="'.$cont['mainlink'].'">'.$cont['maintitle']. '</a><br /><br />';
		$data .= "</div>";
		$data .= "<div class=\"post-content-planet\">";
		$data .= $cont['content'].'&nbsp;<a href="'.$cont['link'].'">suite...</a>'."\n"; 
		$data .= "</div><br />";
		}
		$data.="</div>";
		$fd = fopen($file_cache, "w");
		fputs($fd, $data);
		fclose($fd);
	} // fin if $en_cache
	return $check;
} // fin affiche_fil_planet


?>
